'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Fork = function () {
  function Fork(config) {
    _classCallCheck(this, Fork);

    this.config = config;
  }

  _createClass(Fork, [{
    key: 'setListener',
    value: function setListener(listener) {
      this.listener = listener;
    }
  }, {
    key: 'setBifurcacion',
    value: function setBifurcacion(bifurcacion) {
      var _this = this;

      this.bifurcacion = bifurcacion;

      var exists = this.bifurcacion.find(function (obj) {
        var appName = obj.appName,
            version = obj.version,
            name = obj.name;


        if (!appName) {
          appName = _this.config.APPLICATION_APP;
        }

        if (!version) {
          version = _this.config.APPLICATION_VERSION;
        }

        var current = appName + '_' + version + '_' + name;

        if (version === 'v1' && appName === 'appcoppel') {
          current = name;
        }

        return current === _this.config.TOPIC;
      });

      if (!exists) {
        this.bifurcacion.unshift({
          appName: this.config.APPLICATION_APP,
          version: this.config.APPLICATION_VERSION,
          name: this.config.APPLICATION_NAME
        });
      }
    }
  }, {
    key: 'getNextTopic',
    value: function getNextTopic(worker) {
      var appName = worker.appName,
          version = worker.version,
          name = worker.name;

      var current = appName + '_' + version + '_' + name;

      if (version === 'v1' && this.config.APPLICATION_APP === 'appcoppel') {
        current = name;
      }

      return { current: current, name: name };
    }
  }, {
    key: 'send',
    value: function send(data, response, final) {
      data.data = response;

      var topic = data.metadata.worker;
      if (final) {
        data = {
          _id: data.metadata.id_transaction,
          response: {
            data: {
              response: response
            },
            meta: {
              id_transaction: data.metadata.id_transaction,
              status: 'SUCCESS'
            }
          },
          metadata: data.metadata.metadata_inicial
        };
        topic = 'respuesta_' + data.metadata.callback;

        if (response.meta) {
          data.response = response;
        }
      }

      if (this.config.DEBUG) {
        console.log('SALIDA [-> ' + topic + ']: ' + JSON.stringify(data));
      }
      response = Buffer.from(JSON.stringify(data)).toString('base64');

      this.producer.send([{
        topic: topic,
        messages: [response]
      }], function (err, _) {
        if (err) console.error(err);
      });
    }
  }, {
    key: 'error',
    value: function error(data) {
      var response = {
        metadata: data.metadata,
        headers: data.headers,
        data: data.data,
        response: {
          errorCode: -99,
          userMessage: 'Ocurrio una excepcion, favor de intentar de nuevo.'
        }
      };

      response.metadata.time = new Date().toISOString();
      response.metadata.worker = response.metadata.owner;
      response.metadata.owner = this.config.TOPIC;
      response.metadata.mtype = 'output';

      var uowner = '';
      var uworker = '';
      if ('uowner' in response.metadata) {
        uowner = response.metadata.uowner;
      }

      if ('uworker' in response.metadata) {
        uworker = response.metadata.uworker;
      }

      response.metadata.uworker = uowner;
      response.metadata.uowner = uworker;

      var topic = 'respuesta_' + response.metadata.owner;

      response = {
        _id: response.metadata.id_transaction,
        response: response.response,
        metadata: response.metadata
      };

      if (this.config.DEBUG) {
        console.log('SALIDA [' + this.config.TOPIC + ']: ' + JSON.stringify(response));
      }

      response = Buffer.from(JSON.stringify(response)).toString('base64');

      this.producer.send([{
        topic: topic,
        messages: [response]
      }], function (err, _) {
        if (err) console.error(err);
      });
    }
  }, {
    key: 'message',
    value: function message(data) {
      var _this2 = this;

      data.metadata.mtype = 'input';
      data.metadata.time = new Date().toISOString();
      data.metadata.bifurcacion = true;

      var transactionId = data.metadata.id_transaction;

      if (!('metadata_inicial' in data.metadata)) {
        data.metadata.metadata_inicial = Object.assign({}, data.metadata);
      }
      if (!('data_inicial' in data.metadata)) {
        data.metadata.data_inicial = Object.assign({}, data.data);
      }

      var size = this.bifurcacion.length;
      var found = false;

      var _loop = function _loop(index) {
        var obj = _this2.bifurcacion[index];

        var _getNextTopic = _this2.getNextTopic(obj),
            current = _getNextTopic.current,
            name = _getNextTopic.name;

        if (current === data.metadata.owner) {
          found = true;

          if (index + 1 < _this2.bifurcacion.length) {
            var row = _this2.getNextTopic(_this2.bifurcacion[index + 1]);

            var operationId = new Date().getTime() / 1000000;
            data.metadata.id_operacion = Math.floor(operationId);
            data.metadata.uowner = data.metadata.uworker;
            data.metadata.worker = row.current;
            data.metadata.uworker = data.metadata.worker + '_' + data.metadata.id_operacion;
            data.metadata.owner = _this2.config.TOPIC;
          }

          if (_this2.config.DEBUG) {
            if (index === 0) {
              console.log('ENTRADA [' + current + ']: HEADERS: [' + JSON.stringify(data.headers) + '] DATA: [' + JSON.stringify(data.data) + ']');
            } else {
              console.log('ENTRADA [' + current + ']: HEADERS: [' + JSON.stringify(data.headers) + '] DATA: [' + JSON.stringify(data.response) + ']');
            }
          }

          if (index > 0 && data.response && data.response.data && data.response.data.response && data.response.data.response.errorCode) {
            return {
              v: _this2.send(data, data.response, true)
            };
          }

          var promise = new Promise(function (resolve, reject) {
            var initialData = data.metadata.data_inicial;
            var response = data.data;
            var microservice = name;

            _this2.listener({ resolve: resolve, reject: reject }, { microservice: microservice, transactionId: transactionId, initialData: initialData, response: response });
          });

          promise.then(function (response) {
            if (response === null || response === undefined || JSON.stringify(response) === '{}') {
              response = data.data;
            }
            _this2.send(data, response, index + 1 === size);
          });

          promise.catch(function (err) {
            console.error(err);
            _this2.sendError(_this2.config.TOPIC, err, transactionId);
            _this2.error({
              metadata: {
                owner: data.metadata.callback,
                id_transaction: transactionId
              },
              headers: {},
              data: {}
            });
          });
        }
      };

      for (var index = 0; index < size && !found; index++) {
        var _ret = _loop(index);

        if ((typeof _ret === 'undefined' ? 'undefined' : _typeof(_ret)) === "object") return _ret.v;
      }
    }
  }]);

  return Fork;
}();

exports.default = Fork;